unit Main;

interface

uses
  Windows, SysUtils, Classes, Forms,
  Buttons, Menus, IniFiles, StdCtrls, Controls, iChii;

type
  TMainForm = class(TForm)
    Memo1: TMemo;
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuMisc: TMenuItem;
    MenuInfo: TMenuItem;
    MenuExit: TMenuItem;
    MenuConfig: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuInfoClick(Sender: TObject);
    procedure MenuConfigClick(Sender: TObject);
  private
    FIniFile    : TIniFile;
    procedure   MessageOut(AMsg: string);
  public
    
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    Info, Config;

(*
    ===========================================================================
    bZ[W\
    ===========================================================================
*)
procedure TMainForm.MessageOut(AMsg: string);
begin
    if (Memo1.Lines.Count > 200) then Memo1.Lines.Clear();
    Memo1.Lines.Add(AMsg);
end;

(*
    ===========================================================================
    j[/I
    ===========================================================================
*)
procedure TMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close;
end;

(*
    ===========================================================================
    j[/
    ===========================================================================
*)
procedure TMainForm.MenuInfoClick(Sender: TObject);
begin
    OpenInfoForm();
end;

(*
    ===========================================================================
    j[/ݒ
    ===========================================================================
*)
procedure TMainForm.MenuConfigClick(Sender: TObject);
begin
    OpenConfigForm();
end;

(*
    ===========================================================================
    tH[RXgN^
    ===========================================================================
*)
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  ʒu
    Self.Top := Screen.Height - Self.Height;
    Self.Left := Screen.Width - Self.Width;

    ClickHere := TClickHereItIs.Create(MessageOut);

    //  ݒt@CǍ
    FIniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
    //  ҂Ԑݒ
    ClickHere.WaitCount := FIniFile.ReadInteger('ClickHere', 'WaitCount', ClickHere.WaitCount);
    //  tH_
    DESKTOP_STR := FIniFile.ReadString('ClickHere', 'Desktop', DESKTOP_STR);
    MYCOMPUTER_STR := FIniFile.ReadString('ClickHere', 'MyComputer', MYCOMPUTER_STR);
    MYNETWORK_STR := FIniFile.ReadString('ClickHere', 'MyNetwork', MYNETWORK_STR);

    ClickHere.Start;
end;

(*
    ===========================================================================
    tH[fXgN^
    ===========================================================================
*)
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    ClickHere.Stop;
    ClickHere.Free;

    //  ҂ԕۑ
    FIniFile.WriteInteger('ClickHere', 'WaitCount', ClickHere.WaitCount);
    //  tH_ۑ
    FIniFile.WriteString('ClickHere', 'Desktop', DESKTOP_STR);
    FIniFile.WriteString('ClickHere', 'MyComputer', MYCOMPUTER_STR);
    FIniFile.WriteString('ClickHere', 'MyNetwork', MYNETWORK_STR);

    FIniFile.Free;
end;

end.

