(*
    ===========================================================================

    LANZX

    ---------------------------------------------------------------------------

    Gen's LowTech : bZ[WtbNg
    http://www2.biglobe.ne.jp/~sakai/usehook.htm
    http://www2.biglobe.ne.jp/~sakai/bin/list2.txt

    ---------------------------------------------------------------------------

    MMF = Memory Mapped File

    ===========================================================================
*)

unit iFMO;

interface

uses
    Windows, SysUtils, misc;

function    CreateFileMappingObject(const ADataSize: integer; const AName: string): Cardinal;
procedure   DestroyFileMappingObject(var AFileMappingObject: THandle);
procedure   GetFileMappingObject(var h: THandle; var p: Pointer; const AName: string);
procedure   ReleaseFileMappingObject(var h: THandle; var p: Pointer);

implementation

//  MMFȂ
procedure   ErrCantCreateMMF(const AName: string);
const
    MSG = 'Cannnot Create Memory Mapped File :[%s]';
begin
    PutLog(Format(MSG, [AName]));
end;

//  MMFJȂ
procedure   ErrCantOpenMMF(const AName: string);
const
    MSG = 'Cannnot Open Memory Mapped File :[%s]';
begin
    PutLog(Format(MSG, [AName]));
end;

//  MMF蓖ĂȂ
procedure   ErrCantMapView(const AName: string);
const
    MSG = 'Cannnot Mapping Memory Mapped File :[%s]';
begin
    PutLog(Format(MSG, [AName]));
end;

//  MMF͍Ă܂
procedure   ErrAlwaysCreatedByOtherWindowMMF(const AHandle: HWND);
const
    MSG = 'Always Created By Other Window :[%d]';
begin
    PutLog(Format(MSG, [AHandle]));
end;

(*
    -----------------------------------------------------------------
    t@C}bsOIuWFNg쐬(̖߂l)
    -----------------------------------------------------------------
*)
function    CreateFileMappingObject(const ADataSize: integer; const AName: string): Cardinal;
begin
    //  MMF쐬
    Result := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0, ADataSize, PChar(AName));
    //  ǂ?
    if (Result = 0) then
    begin
        ErrCantCreateMMF(AName);
    end;
end;

(*
    -----------------------------------------------------------------
    t@C}bsOIuWFNg쐬(̈ɂĔj)
    -----------------------------------------------------------------
*)
procedure   DestroyFileMappingObject(var AFileMappingObject: THandle);
begin
    //MMFJ
    if (AFileMappingObject <> 0) then
    begin
        CloseHandle(AFileMappingObject);
    end;
end;

(*
    -----------------------------------------------------------------
    LANZX̂߂̏(var)
    -----------------------------------------------------------------
*)
procedure   GetFileMappingObject(var h: THandle; var p: Pointer; const AName: string);
begin
    //MMFJ
    h := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, PChar(AName));
    //  JȂ
    if (h = 0) then
    begin
        ErrCantOpenMMF(AName);
    end
    else
    //  J
    begin
        //MMF̊蓖
        p := MapViewOfFile(h, FILE_MAP_ALL_ACCESS, 0, 0, 0);
        if (p = nil) then
        begin
            CloseHandle(h);
            ErrCantMapView(AName);
        end;
    end;
end;

(*
    -----------------------------------------------------------------
    LANZX̂߂̌n(̈ɂĔj)
    -----------------------------------------------------------------
*)
procedure ReleaseFileMappingObject(var h: THandle; var p: Pointer);
begin
    //  MMF̃r[
    if (p <> nil) then
    begin
        UnmapViewOfFile(p);
    end;
    //  MMF̃nh
    if (h <> 0) then
    begin
        CloseHandle(h);
    end;
end;



end.

